diff -caPr ..\vimorg/src/main.c ./src/main.c
*** ..\vimorg/src/main.c	2010-04-19 14:14:44.658809100 +0200
--- ./src/main.c	2010-04-19 17:39:53.454328200 +0200
***************
*** 1352,1357 ****
--- 1352,1360 ----
  #ifdef FEAT_PYTHON
      python_end();
  #endif
+ #ifdef FEAT_PYTHON3
+     python3_end();
+ #endif
  #ifdef FEAT_PERL
      perl_end();
  #endif
diff -caPr ..\vimorg/src/Make_bc5.mak ./src/Make_bc5.mak
*** ..\vimorg/src/Make_bc5.mak	2010-04-19 14:14:44.580721100 +0200
--- ./src/Make_bc5.mak	2010-04-19 17:39:53.469948200 +0200
***************
*** 41,46 ****
--- 41,49 ----
  # PYTHON	define to path to Python dir to get PYTHON support (not defined)
  #   PYTHON_VER	    define to version of Python being used (22)
  #   DYNAMIC_PYTHON  no or yes: use yes to load the Python DLL dynamically (no)
+ # PYTHON3	define to path to Python3 dir to get PYTHON3 support (not defined)
+ #   PYTHON3_VER	    define to version of Python3 being used (31)
+ #   DYNAMIC_PYTHON3  no or yes: use yes to load the Python3 DLL dynamically (no)
  # TCL		define to path to TCL dir to get TCL support (not defined)
  #   TCL_VER	define to version of TCL being used (83)
  #   DYNAMIC_TCL no or yes: use yes to load the TCL DLL dynamically (no)
***************
*** 135,140 ****
--- 138,146 ----
  ### PYTHON: uncomment this line if you want python support in vim
  # PYTHON=c:\python22
  
+ ### PYTHON3: uncomment this line if you want python3 support in vim
+ # PYTHON3=c:\python31
+ 
  ### RUBY: uncomment this line if you want ruby support in vim
  # RUBY=c:\ruby
  
***************
*** 200,205 ****
--- 206,212 ----
  #   don't use FASTCALL when linking with external libs.
  !if ("$(FASTCALL)"=="") && \
  	("$(PYTHON)"=="") && \
+ 	("$(PYTHON3)"=="") && \
  	("$(PERL)"=="") && \
  	("$(TCL)"=="") && \
  	("$(RUBY)"=="") && \
***************
*** 309,316 ****
  !endif
  
  !ifdef PYTHON
  INTERP_DEFINES = $(INTERP_DEFINES) -DFEAT_PYTHON
- INCLUDE = $(PYTHON)\include;$(INCLUDE)
  !ifndef PYTHON_VER
  PYTHON_VER = 22
  !endif
--- 316,329 ----
  !endif
  
  !ifdef PYTHON
+ !ifdef PYTHON3
+ DYNAMIC_PYTHON=yes
+ DYNAMIC_PYTHON3=yes
+ !endif
+ !endif
+ 
+ !ifdef PYTHON
  INTERP_DEFINES = $(INTERP_DEFINES) -DFEAT_PYTHON
  !ifndef PYTHON_VER
  PYTHON_VER = 22
  !endif
***************
*** 320,325 ****
--- 333,350 ----
  !endif
  !endif
  
+ !ifdef PYTHON3
+ INTERP_DEFINES = $(INTERP_DEFINES) -DFEAT_PYTHON3
+ !ifndef PYTHON3_VER
+ PYTHON3_VER = 31
+ !endif
+ !if "$(DYNAMIC_PYTHON3)" == "yes"
+ INTERP_DEFINES = $(INTERP_DEFINES) -DDYNAMIC_PYTHON3 -DDYNAMIC_PYTHON3_DLL=\"python$(PYTHON3_VER).dll\"
+ PYTHON3_LIB_FLAG = /nodefaultlib:
+ !endif
+ !endif
+ 
+ 
  !ifdef RUBY
  !ifndef RUBY_VER
  RUBY_VER = 16
***************
*** 592,597 ****
--- 617,627 ----
      $(OBJDIR)\if_python.obj
  !endif
  
+ !ifdef PYTHON3
+ vimobj = $(vimobj) \
+     $(OBJDIR)\if_python3.obj
+ !endif
+ 
  !ifdef RUBY
  vimobj = $(vimobj) \
      $(OBJDIR)\if_ruby.obj
***************
*** 702,707 ****
--- 732,743 ----
  MSG = $(MSG)(dynamic)
  ! endif
  !endif
+ !ifdef PYTHON3
+ MSG = $(MSG) PYTHON3
+ ! if "$(DYNAMIC_PYTHON3)" == "yes"
+ MSG = $(MSG)(dynamic)
+ ! endif
+ !endif
  !ifdef RUBY
  MSG = $(MSG) RUBY
  ! if "$(DYNAMIC_RUBY)" == "yes"
***************
*** 792,797 ****
--- 828,836 ----
  !ifdef PYTHON
  	-@del python.lib
  !endif
+ !ifdef PYTHON3
+ 	-@del python3.lib
+ !endif
  !ifdef RUBY
  	-@del ruby.lib
  !endif
***************
*** 829,834 ****
--- 868,876 ----
  !ifdef PYTHON
  	$(PYTHON_LIB_FLAG)python.lib+
  !endif
+ !ifdef PYTHON3
+ 	$(PYTHON3_LIB_FLAG)python3.lib+
+ !endif
  !ifdef RUBY
  	$(RUBY_LIB_FLAG)ruby.lib+
  !endif
***************
*** 878,883 ****
--- 920,928 ----
  !ifdef PYTHON
  	$(PYTHON_LIB_FLAG)python.lib+
  !endif
+ !ifdef PYTHON3
+ 	$(PYTHON3_LIB_FLAG)python3.lib+
+ !endif
  !ifdef RUBY
  	$(RUBY_LIB_FLAG)ruby.lib+
  !endif
***************
*** 918,924 ****
  	    $(PERL)\lib\ExtUtils\typemap if_perl.xs > $@
  
  $(OBJDIR)\if_python.obj: if_python.c python.lib
! 	$(CC) $(CCARG) $(CC1) $(CC2)$@ -pc if_python.c
  
  $(OBJDIR)\if_ruby.obj: if_ruby.c ruby.lib
  	$(CC) $(CCARG) $(CC1) $(CC2)$@ -pc if_ruby.c
--- 963,972 ----
  	    $(PERL)\lib\ExtUtils\typemap if_perl.xs > $@
  
  $(OBJDIR)\if_python.obj: if_python.c python.lib
! 	$(CC) -I$(PYTHON)\include $(CCARG) $(CC1) $(CC2)$@ -pc if_python.c
! 
! $(OBJDIR)\if_python3.obj: if_python3.c python3.lib
! 	$(CC) -I$(PYTHON3)\include $(CCARG) $(CC1) $(CC2)$@ -pc if_python3.c
  
  $(OBJDIR)\if_ruby.obj: if_ruby.c ruby.lib
  	$(CC) $(CCARG) $(CC1) $(CC2)$@ -pc if_ruby.c
***************
*** 970,975 ****
--- 1018,1026 ----
  python.lib: $(PYTHON)\libs\python$(PYTHON_VER).lib
  	coff2omf $(PYTHON)\libs\python$(PYTHON_VER).lib $@
  
+ python3.lib: $(PYTHON3)\libs\python$(PYTHON3_VER).lib
+ 	coff2omf $(PYTHON3)\libs\python$(PYTHON3_VER).lib $@
+ 
  ruby.lib: $(RUBY)\lib\$(RUBY_INSTALL_NAME).lib
  	coff2omf $(RUBY)\lib\$(RUBY_INSTALL_NAME).lib $@
  
***************
*** 1018,1020 ****
--- 1069,1072 ----
  | $@
  
  # vi:set sts=4 sw=4:
+ 
diff -caPr ..\vimorg/src/Make_cyg.mak ./src/Make_cyg.mak
*** ..\vimorg/src/Make_cyg.mak	2010-04-19 14:14:44.346457100 +0200
--- ./src/Make_cyg.mak	2010-04-19 17:39:53.469948200 +0200
***************
*** 14,19 ****
--- 14,22 ----
  # PYTHON	define to path to Python dir to get PYTHON support (not defined)
  #   PYTHON_VER	    define to version of Python being used (22)
  #   DYNAMIC_PYTHON  no or yes: use yes to load the Python DLL dynamically (yes)
+ # PYTHON3	define to path to Python3 dir to get PYTHON3 support (not defined)
+ #   PYTHON3_VER	    define to version of Python3 being used (22)
+ #   DYNAMIC_PYTHON3  no or yes: use yes to load the Python3 DLL dynamically (yes)
  # TCL		define to path to TCL dir to get TCL support (not defined)
  #   TCL_VER	define to version of TCL being used (83)
  #   DYNAMIC_TCL no or yes: use yes to load the TCL DLL dynamically (yes)
***************
*** 135,141 ****
  ##############################
  ifdef PYTHON
  DEFINES += -DFEAT_PYTHON
- INCLUDES += -I$(PYTHON)/include
  EXTRA_OBJS += $(OUTDIR)/if_python.o
  
  ifndef DYNAMIC_PYTHON
--- 138,143 ----
***************
*** 154,159 ****
--- 156,184 ----
  endif
  
  ##############################
+ # DYNAMIC_PYTHON3=yes works.
+ # DYNAMIC_PYTHON3=no does not (unresolved externals on link).
+ ##############################
+ ifdef PYTHON3
+ DEFINES += -DFEAT_PYTHON3
+ EXTRA_OBJS += $(OUTDIR)/if_python3.o
+ 
+ ifndef DYNAMIC_PYTHON3
+ DYNAMIC_PYTHON3 = yes
+ endif
+ 
+ ifndef PYTHON3_VER
+ PYTHON3_VER = 31
+ endif
+ 
+ ifeq (yes, $(DYNAMIC_PYTHON3))
+ DEFINES += -DDYNAMIC_PYTHON3 -DDYNAMIC_PYTHON3_DLL=\"python$(PYTHON3_VER).dll\"
+ else
+ EXTRA_LIBS += $(PYTHON3)/libs/python$(PYTHON3_VER).lib
+ endif
+ endif
+ 
+ ##############################
  # DYNAMIC_RUBY=yes works.
  # DYNAMIC_RUBY=no does not (process exits).
  ##############################
***************
*** 533,538 ****
--- 558,569 ----
  $(OUTDIR)/if_ole.o:	if_ole.cpp $(INCL)
  	$(CC) -c $(CFLAGS) if_ole.cpp -o $(OUTDIR)/if_ole.o
  
+ $(OUTDIR)/if_python.o : if_python.c $(INCL)
+ 	$(CC) -c $(CFLAGS) -I$(PYTHON)/include $< -o $@
+ 
+ $(OUTDIR)/if_python3.o : if_python3.c $(INCL)
+ 	$(CC) -c $(CFLAGS) -I$(PYTHON3)/include $< -o $@
+ 
  if_perl.c: if_perl.xs typemap
  	$(PERL)/bin/perl `cygpath -d $(PERL)/lib/ExtUtils/xsubpp` \
  		-prototypes -typemap \
***************
*** 582,584 ****
--- 613,616 ----
  	@echo char_u *compiled_user = (char_u *)"$(USERNAME)"; >> pathdef.c
  	@echo char_u *compiled_sys = (char_u *)"$(USERDOMAIN)"; >> pathdef.c
  endif
+ 
diff -caPr ..\vimorg/src/Make_ming.mak ./src/Make_ming.mak
*** ..\vimorg/src/Make_ming.mak	2010-04-19 14:14:44.393309900 +0200
--- ./src/Make_ming.mak	2010-04-19 17:39:53.485568200 +0200
***************
*** 177,182 ****
--- 177,204 ----
  endif
  endif
  
+ #PYTHON3: See comment for Python 2 above
+ 
+ ifdef PYTHON3
+ ifndef DYNAMIC_PYTHON3
+ DYNAMIC_PYTHON3=yes
+ endif
+ 
+ ifndef PYTHON3_VER
+ PYTHON3_VER=31
+ endif
+ 
+ ifeq (no,$(DYNAMIC_PYTHON3))
+ PYTHON3LIB=-L$(PYTHON3)/libs -lPYTHON$(PYTHON3_VER)
+ endif
+ 
+ ifeq ($(CROSS),no)
+ PYTHON3INC=-I $(PYTHON3)/include
+ else
+ PYTHON3INC=-I $(PYTHON3)/win32inc
+ endif
+ endif
+ 
  #	TCL interface:
  #	  TCL=[Path to TCL directory]
  #	  DYNAMIC_TCL=yes (to load the TCL DLL dynamically)
***************
*** 310,318 ****
  endif
  
  ifdef PYTHON
! CFLAGS += -DFEAT_PYTHON $(PYTHONINC)
  ifeq (yes, $(DYNAMIC_PYTHON))
! CFLAGS += -DDYNAMIC_PYTHON -DDYNAMIC_PYTHON_DLL=\"python$(PYTHON_VER).dll\"
  endif
  endif
  
--- 332,347 ----
  endif
  
  ifdef PYTHON
! CFLAGS += -DFEAT_PYTHON 
  ifeq (yes, $(DYNAMIC_PYTHON))
! CFLAGS += -DDYNAMIC_PYTHON
! endif
! endif
! 
! ifdef PYTHON3 
! CFLAGS += -DFEAT_PYTHON3 
! ifeq (yes, $(DYNAMIC_PYTHON3))
! CFLAGS += -DDYNAMIC_PYTHON3 
  endif
  endif
  
***************
*** 439,444 ****
--- 468,476 ----
  ifdef PYTHON
  OBJ += $(OUTDIR)/if_python.o
  endif
+ ifdef PYTHON3
+ OBJ += $(OUTDIR)/if_python3.o
+ endif
  ifdef RUBY
  OBJ += $(OUTDIR)/if_ruby.o
  endif
***************
*** 547,553 ****
  	$(CC) $(CFLAGS) -o uninstal.exe uninstal.c $(LIB)
  
  $(TARGET): $(OUTDIR) $(OBJ)
! 	$(CC) $(CFLAGS) $(LFLAGS) -o $@ $(OBJ) $(LIB) -lole32 -luuid $(MZSCHEME_LIBDIR) $(MZSCHEME_LIB) $(PYTHONLIB) $(RUBYLIB)
  
  upx: exes
  	upx gvim.exe
--- 579,585 ----
  	$(CC) $(CFLAGS) -o uninstal.exe uninstal.c $(LIB)
  
  $(TARGET): $(OUTDIR) $(OBJ)
! 	$(CC) $(CFLAGS) $(LFLAGS) -o $@ $(OBJ) $(LIB) -lole32 -luuid $(MZSCHEME_LIBDIR) $(MZSCHEME_LIB) $(PYTHONLIB) $(PYTHON3LIB) $(RUBYLIB)
  
  upx: exes
  	upx gvim.exe
***************
*** 579,584 ****
--- 611,622 ----
  	structs.h regexp.h option.h ex_cmds.h proto.h globals.h farsi.h \
  	gui.h
  
+ $(OUTDIR)/if_python.o : if_python.c $(INCL)
+ 	$(CC) -c $(CFLAGS) $(PYTHONINC) -DDYNAMIC_PYTHON_DLL=\"python$(PYTHON_VER).dll\" $< -o $@
+ 
+ $(OUTDIR)/if_python3.o : if_python3.c $(INCL)
+ 	$(CC) -c $(CFLAGS) $(PYTHON3INC) -DDYNAMIC_PYTHON3_DLL=\"PYTHON$(PYTHON3_VER).dll\" $< -o $@
+ 
  $(OUTDIR)/%.o : %.c $(INCL)
  	$(CC) -c $(CFLAGS) $< -o $@
  
***************
*** 630,636 ****
  	@echo 'char_u *default_vim_dir = (char_u *)"$(VIMRCLOC)";' >> pathdef.c
  	@echo 'char_u *default_vimruntime_dir = (char_u *)"$(VIMRUNTIMEDIR)";' >> pathdef.c
  	@echo 'char_u *all_cflags = (char_u *)"$(CC) $(CFLAGS)";' >> pathdef.c
! 	@echo 'char_u *all_lflags = (char_u *)"$(CC) $(CFLAGS) $(LFLAGS) -o $(TARGET) $(LIB) -lole32 -luuid $(MZSCHEME_LIBDIR) $(MZSCHEME_LIB) $(PYTHONLIB) $(RUBYLIB)";' >> pathdef.c
  	@echo 'char_u *compiled_user = (char_u *)"$(USERNAME)";' >> pathdef.c
  	@echo 'char_u *compiled_sys = (char_u *)"$(USERDOMAIN)";' >> pathdef.c
  else
--- 668,674 ----
  	@echo 'char_u *default_vim_dir = (char_u *)"$(VIMRCLOC)";' >> pathdef.c
  	@echo 'char_u *default_vimruntime_dir = (char_u *)"$(VIMRUNTIMEDIR)";' >> pathdef.c
  	@echo 'char_u *all_cflags = (char_u *)"$(CC) $(CFLAGS)";' >> pathdef.c
! 	@echo 'char_u *all_lflags = (char_u *)"$(CC) $(CFLAGS) $(LFLAGS) -o $(TARGET) $(LIB) -lole32 -luuid $(MZSCHEME_LIBDIR) $(MZSCHEME_LIB) $(PYTHONLIB) $(PYTHON3LIB) $(RUBYLIB)";' >> pathdef.c
  	@echo 'char_u *compiled_user = (char_u *)"$(USERNAME)";' >> pathdef.c
  	@echo 'char_u *compiled_sys = (char_u *)"$(USERDOMAIN)";' >> pathdef.c
  else
***************
*** 640,646 ****
  	@echo char_u *default_vim_dir = (char_u *)"$(VIMRCLOC)"; >> pathdef.c
  	@echo char_u *default_vimruntime_dir = (char_u *)"$(VIMRUNTIMEDIR)"; >> pathdef.c
  	@echo char_u *all_cflags = (char_u *)"$(CC) $(CFLAGS)"; >> pathdef.c
! 	@echo char_u *all_lflags = (char_u *)"$(CC) $(CFLAGS) $(LFLAGS) -o $(TARGET) $(LIB) -lole32 -luuid $(MZSCHEME_LIBDIR) $(MZSCHEME_LIB) $(PYTHONLIB) $(RUBYLIB)"; >> pathdef.c
  	@echo char_u *compiled_user = (char_u *)"$(USERNAME)"; >> pathdef.c
  	@echo char_u *compiled_sys = (char_u *)"$(USERDOMAIN)"; >> pathdef.c
  endif
--- 678,685 ----
  	@echo char_u *default_vim_dir = (char_u *)"$(VIMRCLOC)"; >> pathdef.c
  	@echo char_u *default_vimruntime_dir = (char_u *)"$(VIMRUNTIMEDIR)"; >> pathdef.c
  	@echo char_u *all_cflags = (char_u *)"$(CC) $(CFLAGS)"; >> pathdef.c
! 	@echo char_u *all_lflags = (char_u *)"$(CC) $(CFLAGS) $(LFLAGS) -o $(TARGET) $(LIB) -lole32 -luuid $(MZSCHEME_LIBDIR) $(MZSCHEME_LIB) $(PYTHONLIB) $(PYTHON3LIB) $(RUBYLIB)"; >> pathdef.c
  	@echo char_u *compiled_user = (char_u *)"$(USERNAME)"; >> pathdef.c
  	@echo char_u *compiled_sys = (char_u *)"$(USERDOMAIN)"; >> pathdef.c
  endif
+ 
diff -caPr ..\vimorg/src/Make_mvc.mak ./src/Make_mvc.mak
*** ..\vimorg/src/Make_mvc.mak	2010-04-19 14:14:45.455306700 +0200
--- ./src/Make_mvc.mak	2010-04-19 17:39:53.501188200 +0200
***************
*** 47,52 ****
--- 47,57 ----
  #	  DYNAMIC_PYTHON=yes (to load the Python DLL dynamically)
  #	  PYTHON_VER=[Python version, eg 15, 20]  (default is 22)
  #
+ #	Python3 interface:
+ #	  PYTHON3=[Path to Python3 directory]
+ #	  DYNAMIC_PYTHON3=yes (to load the Python3 DLL dynamically)
+ #	  PYTHON3_VER=[Python3 version, eg 30, 31]  (default is 31)
+ #
  #	Ruby interface:
  #	  RUBY=[Path to Ruby directory]
  #	  DYNAMIC_RUBY=yes (to load the Ruby DLL dynamically)
***************
*** 158,163 ****
--- 163,171 ----
  !ifdef PYTHON
  OBJDIR = $(OBJDIR)Y
  !endif
+ !ifdef PYTHON3
+ OBJDIR = $(OBJDIR)H
+ !endif
  !ifdef TCL
  OBJDIR = $(OBJDIR)T
  !endif
***************
*** 600,605 ****
--- 608,620 ----
  !endif
  !endif
  
+ !ifdef PYTHON
+ !ifdef PYTHON3
+ DYNAMIC_PYTHON=yes
+ DYNAMIC_PYTHON3=yes
+ !endif
+ !endif
+ 
  # PYTHON interface
  !ifdef PYTHON
  !ifndef PYTHON_VER
***************
*** 621,626 ****
--- 636,662 ----
  !endif
  !endif
  
+ # PYTHON3 interface
+ !ifdef PYTHON3
+ !ifndef PYTHON3_VER
+ PYTHON3_VER = 31
+ !endif
+ !message Python3 requested (version $(PYTHON3_VER)) - root dir is "$(PYTHON3)"
+ !if "$(DYNAMIC_PYTHON3)" == "yes"
+ !message Python3 DLL will be loaded dynamically
+ !endif
+ CFLAGS = $(CFLAGS) -DFEAT_PYTHON3
+ PYTHON3_OBJ = $(OUTDIR)\if_python3.obj
+ PYTHON3_INC = /I "$(PYTHON3)\Include" /I "$(PYTHON3)\PC"
+ !if "$(DYNAMIC_PYTHON3)" == "yes"
+ CFLAGS = $(CFLAGS) -DDYNAMIC_PYTHON3 \
+ 		-DDYNAMIC_PYTHON3_DLL=\"python$(PYTHON3_VER).dll\"
+ PYTHON3_LIB = /nodefaultlib:python$(PYTHON3_VER).lib
+ !else
+ PYTHON3_LIB = $(PYTHON3)\libs\python$(PYTHON3_VER).lib
+ !endif
+ !endif
+ 
  # MzScheme interface
  !ifdef MZSCHEME
  !message MzScheme requested - root dir is "$(MZSCHEME)"
***************
*** 794,800 ****
  
  LINKARGS1 = $(linkdebug) $(conflags)
  LINKARGS2 = $(CON_LIB) $(GUI_LIB) $(LIBC) $(OLE_LIB)  user32.lib $(SNIFF_LIB) \
! 		$(MZSCHEME_LIB) $(PERL_LIB) $(PYTHON_LIB) $(RUBY_LIB) \
  		$(TCL_LIB) $(NETBEANS_LIB) $(XPM_LIB) $(LINK_PDB)
  
  # Report link time code generation progress if used. 
--- 830,836 ----
  
  LINKARGS1 = $(linkdebug) $(conflags)
  LINKARGS2 = $(CON_LIB) $(GUI_LIB) $(LIBC) $(OLE_LIB)  user32.lib $(SNIFF_LIB) \
! 		$(MZSCHEME_LIB) $(PERL_LIB) $(PYTHON_LIB) $(PYTHON3_LIB) $(RUBY_LIB) \
  		$(TCL_LIB) $(NETBEANS_LIB) $(XPM_LIB) $(LINK_PDB)
  
  # Report link time code generation progress if used. 
***************
*** 810,820 ****
  		GvimExt/gvimext.dll
  
  $(VIM).exe: $(OUTDIR) $(OBJ) $(GUI_OBJ) $(OLE_OBJ) $(OLE_IDL) $(MZSCHEME_OBJ) \
! 		$(PERL_OBJ) $(PYTHON_OBJ) $(RUBY_OBJ) $(TCL_OBJ) $(SNIFF_OBJ) \
  		$(CSCOPE_OBJ) $(NETBEANS_OBJ) $(XPM_OBJ) version.c version.h
  	$(CC) $(CFLAGS) version.c
  	$(link) $(LINKARGS1) -out:$(VIM).exe $(OBJ) $(GUI_OBJ) $(OLE_OBJ) \
! 		$(MZSCHEME_OBJ) $(PERL_OBJ) $(PYTHON_OBJ) $(RUBY_OBJ) \
  		$(TCL_OBJ) $(SNIFF_OBJ) $(CSCOPE_OBJ) $(NETBEANS_OBJ) \
  		$(XPM_OBJ) $(OUTDIR)\version.obj $(LINKARGS2)
  
--- 846,856 ----
  		GvimExt/gvimext.dll
  
  $(VIM).exe: $(OUTDIR) $(OBJ) $(GUI_OBJ) $(OLE_OBJ) $(OLE_IDL) $(MZSCHEME_OBJ) \
! 		$(PERL_OBJ) $(PYTHON_OBJ) $(PYTHON3_OBJ) $(RUBY_OBJ) $(TCL_OBJ) $(SNIFF_OBJ) \
  		$(CSCOPE_OBJ) $(NETBEANS_OBJ) $(XPM_OBJ) version.c version.h
  	$(CC) $(CFLAGS) version.c
  	$(link) $(LINKARGS1) -out:$(VIM).exe $(OBJ) $(GUI_OBJ) $(OLE_OBJ) \
! 		$(MZSCHEME_OBJ) $(PERL_OBJ) $(PYTHON_OBJ) $(PYTHON3_OBJ) $(RUBY_OBJ) \
  		$(TCL_OBJ) $(SNIFF_OBJ) $(CSCOPE_OBJ) $(NETBEANS_OBJ) \
  		$(XPM_OBJ) $(OUTDIR)\version.obj $(LINKARGS2)
  
***************
*** 969,974 ****
--- 1005,1013 ----
  $(OUTDIR)/if_python.obj: $(OUTDIR) if_python.c  $(INCL)
  	$(CC) $(CFLAGS) $(PYTHON_INC) if_python.c
  
+ $(OUTDIR)/if_python3.obj: $(OUTDIR) if_python3.c  $(INCL)
+ 	$(CC) $(CFLAGS) $(PYTHON3_INC) if_python3.c
+ 
  $(OUTDIR)/if_ole.obj: $(OUTDIR) if_ole.cpp  $(INCL) if_ole.h
  
  $(OUTDIR)/if_ruby.obj: $(OUTDIR) if_ruby.c  $(INCL)
diff -caPr ..\vimorg/src/Makefile ./src/Makefile
*** ..\vimorg/src/Makefile	2010-04-19 14:14:45.049249100 +0200
--- ./src/Makefile	2010-04-19 17:39:53.485568200 +0200
***************
*** 40,45 ****
--- 40,46 ----
  #	  each makes Vim quite a bit bigger:
  #		--enable-perlinterp	for Perl interpreter
  #		--enable-pythoninterp	for Python interpreter
+ #		--enable-python3interp	for Python3 interpreter
  #		--enable-rubyinterp	for Ruby interpreter
  #		--enable-tclinterp	for Tcl interpreter
  #		--enable-cscope		for Cscope interface
***************
*** 386,392 ****
  # NOTE: This may cause threading to be enabled, which has side effects (such
  # as using different libraries and debugging becomes more difficult).
  # NOTE: Using this together with Perl may cause a crash in initialization.
! #CONF_OPT_PYTHON = --enable-pythoninterp
  
  # TCL
  # Uncomment this when you want to include the Tcl interface.
--- 387,398 ----
  # NOTE: This may cause threading to be enabled, which has side effects (such
  # as using different libraries and debugging becomes more difficult).
  # NOTE: Using this together with Perl may cause a crash in initialization.
! # For Python3 support make a symbolic link in /usr/local/bin: 
! #	ln -s python3 python3.1
! # If both python2.x and python3.x are enabled then the linking will be via
! # dlopen(), dlsym(), dlclose(), i.e. pythonX.Y.so must be available
! # CONF_OPT_PYTHON = --enable-pythoninterp
! # CONF_OPT_PYTHON3 = --enable-python3interp
  
  # TCL
  # Uncomment this when you want to include the Tcl interface.
***************
*** 1304,1310 ****
  .SUFFIXES: .c .o .pro
  
  PRE_DEFS = -Iproto $(DEFS) $(GUI_DEFS) $(GUI_IPATH) $(CPPFLAGS) $(EXTRA_IPATHS)
! POST_DEFS = $(X_CFLAGS) $(MZSCHEME_CFLAGS) $(PERL_CFLAGS) $(PYTHON_CFLAGS) $(TCL_CFLAGS) $(RUBY_CFLAGS) $(EXTRA_DEFS)
  
  ALL_CFLAGS = $(PRE_DEFS) $(CFLAGS) $(PROFILE_CFLAGS) $(POST_DEFS)
  
--- 1310,1316 ----
  .SUFFIXES: .c .o .pro
  
  PRE_DEFS = -Iproto $(DEFS) $(GUI_DEFS) $(GUI_IPATH) $(CPPFLAGS) $(EXTRA_IPATHS)
! POST_DEFS = $(X_CFLAGS) $(MZSCHEME_CFLAGS) $(PERL_CFLAGS) $(TCL_CFLAGS) $(RUBY_CFLAGS) $(EXTRA_DEFS)
  
  ALL_CFLAGS = $(PRE_DEFS) $(CFLAGS) $(PROFILE_CFLAGS) $(POST_DEFS)
  
***************
*** 1324,1330 ****
  PFLAGS = $(PROTO_FLAGS) -DPROTO $(LINT_CFLAGS)
  
  ALL_LIB_DIRS = $(GUI_LIBS_DIR) $(X_LIBS_DIR)
! ALL_LIBS = $(GUI_LIBS1) $(GUI_X_LIBS) $(GUI_LIBS2) $(X_PRE_LIBS) $(X_LIBS) $(X_EXTRA_LIBS) $(LIBS) $(EXTRA_LIBS) $(MZSCHEME_LIBS) $(PERL_LIBS) $(PYTHON_LIBS) $(TCL_LIBS) $(RUBY_LIBS) $(PROFILE_LIBS)
  
  # abbreviations
  DEST_BIN = $(DESTDIR)$(BINDIR)
--- 1330,1350 ----
  PFLAGS = $(PROTO_FLAGS) -DPROTO $(LINT_CFLAGS)
  
  ALL_LIB_DIRS = $(GUI_LIBS_DIR) $(X_LIBS_DIR)
! ALL_LIBS = $(GUI_LIBS1) \
! 	$(GUI_X_LIBS) \
! 	$(GUI_LIBS2) \
! 	$(X_PRE_LIBS) \
! 	$(X_LIBS) \
! 	$(X_EXTRA_LIBS) \
! 	$(LIBS) \
! 	$(EXTRA_LIBS) \
! 	$(MZSCHEME_LIBS) \
! 	$(PERL_LIBS) \
! 	$(PYTHON_LIBS) \
! 	$(PYTHON3_LIBS) \
! 	$(TCL_LIBS) \
! 	$(RUBY_LIBS) \
! 	$(PROFILE_LIBS) 
  
  # abbreviations
  DEST_BIN = $(DESTDIR)$(BINDIR)
***************
*** 1426,1438 ****
  	$(OS_EXTRA_SRC)
  
  SRC =	$(BASIC_SRC) $(GUI_SRC) $(HANGULIN_SRC) $(MZSCHEME_SRC) \
! 	$(PERL_SRC) $(PYTHON_SRC) $(TCL_SRC) $(RUBY_SRC) \
  	$(SNIFF_SRC) $(WORKSHOP_SRC) $(WSDEBUG_SRC)
  
  TAGS_SRC = *.c *.cpp if_perl.xs
  
  EXTRA_SRC = hangulin.c if_mzsch.c auto/if_perl.c if_perlsfio.c \
! 	    if_python.c if_tcl.c if_ruby.c if_sniff.c gui_beval.c \
  	    workshop.c wsdebug.c integration.c netbeans.c
  
  # All sources, also the ones that are not configured
--- 1446,1458 ----
  	$(OS_EXTRA_SRC)
  
  SRC =	$(BASIC_SRC) $(GUI_SRC) $(HANGULIN_SRC) $(MZSCHEME_SRC) \
! 	$(PERL_SRC) $(PYTHON_SRC) $(PYTHON3_SRC) $(TCL_SRC) $(RUBY_SRC) \
  	$(SNIFF_SRC) $(WORKSHOP_SRC) $(WSDEBUG_SRC)
  
  TAGS_SRC = *.c *.cpp if_perl.xs
  
  EXTRA_SRC = hangulin.c if_mzsch.c auto/if_perl.c if_perlsfio.c \
!  	    $(PYTHON_SRC) $(PYTHON3_SRC) if_tcl.c if_ruby.c if_sniff.c gui_beval.c \
  	    workshop.c wsdebug.c integration.c netbeans.c
  
  # All sources, also the ones that are not configured
***************
*** 1441,1447 ****
  # Which files to check with lint.  Select one of these three lines.  ALL_SRC
  # checks more, but may not work well for checking a GUI that wasn't configured.
  # The perl sources also don't work well with lint.
! LINT_SRC = $(BASIC_SRC) $(GUI_SRC) $(HANGULIN_SRC) $(PYTHON_SRC) $(TCL_SRC) \
  	$(SNIFF_SRC) $(WORKSHOP_SRC) $(WSDEBUG_SRC) $(NETBEANS_SRC)
  #LINT_SRC = $(SRC)
  #LINT_SRC = $(ALL_SRC)
--- 1461,1467 ----
  # Which files to check with lint.  Select one of these three lines.  ALL_SRC
  # checks more, but may not work well for checking a GUI that wasn't configured.
  # The perl sources also don't work well with lint.
! LINT_SRC = $(BASIC_SRC) $(GUI_SRC) $(HANGULIN_SRC) $(PYTHON_SRC) $(PYTHON3_SRC) $(TCL_SRC) \
  	$(SNIFF_SRC) $(WORKSHOP_SRC) $(WSDEBUG_SRC) $(NETBEANS_SRC)
  #LINT_SRC = $(SRC)
  #LINT_SRC = $(ALL_SRC)
***************
*** 1499,1504 ****
--- 1519,1525 ----
  	$(MZSCHEME_OBJ) \
  	$(PERL_OBJ) \
  	$(PYTHON_OBJ) \
+ 	$(PYTHON3_OBJ) \
  	$(TCL_OBJ) \
  	$(RUBY_OBJ) \
  	$(OS_EXTRA_OBJ) \
***************
*** 1527,1532 ****
--- 1548,1554 ----
  	if_cscope.pro \
  	if_xcmdsrv.pro \
  	if_python.pro \
+ 	if_python3.pro \
  	if_ruby.pro \
  	main.pro \
  	mark.pro \
***************
*** 1587,1593 ****
  		CC="$(CC)" CPPFLAGS="$(CPPFLAGS)" CFLAGS="$(CFLAGS)" \
  		LDFLAGS="$(LDFLAGS)" $(CONF_SHELL) srcdir="$(srcdir)" \
  		./configure $(CONF_OPT_GUI) $(CONF_OPT_X) $(CONF_OPT_XSMP) \
! 		$(CONF_OPT_DARWIN) $(CONF_OPT_PERL) $(CONF_OPT_PYTHON) \
  		$(CONF_OPT_TCL) $(CONF_OPT_RUBY) $(CONF_OPT_NLS) \
  		$(CONF_OPT_CSCOPE) $(CONF_OPT_MULTIBYTE) $(CONF_OPT_INPUT) \
  		$(CONF_OPT_OUTPUT) $(CONF_OPT_GPM) $(CONF_OPT_WORKSHOP) \
--- 1609,1615 ----
  		CC="$(CC)" CPPFLAGS="$(CPPFLAGS)" CFLAGS="$(CFLAGS)" \
  		LDFLAGS="$(LDFLAGS)" $(CONF_SHELL) srcdir="$(srcdir)" \
  		./configure $(CONF_OPT_GUI) $(CONF_OPT_X) $(CONF_OPT_XSMP) \
! 		$(CONF_OPT_DARWIN) $(CONF_OPT_PERL) $(CONF_OPT_PYTHON) $(CONF_OPT_PYTHON3) \
  		$(CONF_OPT_TCL) $(CONF_OPT_RUBY) $(CONF_OPT_NLS) \
  		$(CONF_OPT_CSCOPE) $(CONF_OPT_MULTIBYTE) $(CONF_OPT_INPUT) \
  		$(CONF_OPT_OUTPUT) $(CONF_OPT_GPM) $(CONF_OPT_WORKSHOP) \
***************
*** 2448,2455 ****
  objects/if_perlsfio.o: if_perlsfio.c
  	$(CCC) -o $@ if_perlsfio.c
  
! objects/if_python.o: if_python.c
! 	$(CCC) -o $@ $(PYTHON_CFLAGS_EXTRA) if_python.c
  
  objects/if_ruby.o: if_ruby.c
  	$(CCC) -o $@ if_ruby.c
--- 2470,2493 ----
  objects/if_perlsfio.o: if_perlsfio.c
  	$(CCC) -o $@ if_perlsfio.c
  
! objects/py_config.o: $(PYTHON_CONFDIR)/config.c
! 	$(CCC) $(PYTHON_CFLAGS) -o $@ $(PYTHON_CONFDIR)/config.c \
! 		-I$(PYTHON_CONFDIR) -DHAVE_CONFIG_H -DNO_MAIN
! 
! objects/py_getpath.o: $(PYTHON_CONFDIR)/getpath.c
! 	$(CCC) $(PYTHON_CFLAGS) -o $@ $(PYTHON_CONFDIR)/getpath.c \
! 		-I$(PYTHON_CONFDIR) -DHAVE_CONFIG_H -DNO_MAIN \
! 		$(PYTHON_GETPATH_CFLAGS)
! 
! objects/py3_config.o: $(PYTHON3_CONFDIR)/config.c
! 	$(CCC) $(PYTHON3_CFLAGS) -o $@ $(PYTHON3_CONFDIR)/config.c \
! 		-I$(PYTHON3_CONFDIR) -DHAVE_CONFIG_H -DNO_MAIN
! 
! objects/if_python.o: if_python.c 
! 	$(CCC) $(PYTHON_CFLAGS) $(PYTHON_CFLAGS_EXTRA) -o $@ if_python.c
! 
! objects/if_python3.o: if_python3.c 
! 	$(CCC) $(PYTHON3_CFLAGS) $(PYTHON3_CFLAGS_EXTRA) -o $@ if_python3.c
  
  objects/if_ruby.o: if_ruby.c
  	$(CCC) -o $@ if_ruby.c
***************
*** 2520,2534 ****
  objects/pathdef.o: auto/pathdef.c
  	$(CCC) -o $@ auto/pathdef.c
  
- objects/py_config.o: $(PYTHON_CONFDIR)/config.c
- 	$(CCC) -o $@ $(PYTHON_CONFDIR)/config.c \
- 		-I$(PYTHON_CONFDIR) -DHAVE_CONFIG_H -DNO_MAIN
- 
- objects/py_getpath.o: $(PYTHON_CONFDIR)/getpath.c
- 	$(CCC) -o $@ $(PYTHON_CONFDIR)/getpath.c \
- 		-I$(PYTHON_CONFDIR) -DHAVE_CONFIG_H -DNO_MAIN \
- 		$(PYTHON_GETPATH_CFLAGS)
- 
  objects/pty.o: pty.c
  	$(CCC) -o $@ pty.c
  
--- 2558,2563 ----
***************
*** 2947,2952 ****
--- 2976,2985 ----
    auto/osdef.h ascii.h keymap.h term.h macros.h option.h structs.h \
    regexp.h gui.h gui_beval.h proto/gui_beval.pro ex_cmds.h proto.h \
    globals.h farsi.h arabic.h
+ objects/if_python3.o: if_python3.c vim.h auto/config.h feature.h os_unix.h \
+   auto/osdef.h ascii.h keymap.h term.h macros.h option.h structs.h \
+   regexp.h gui.h gui_beval.h proto/gui_beval.pro ex_cmds.h proto.h \
+   globals.h farsi.h arabic.h
  objects/if_tcl.o: if_tcl.c vim.h auto/config.h feature.h os_unix.h auto/osdef.h \
    ascii.h keymap.h term.h macros.h option.h structs.h regexp.h gui.h \
    gui_beval.h proto/gui_beval.pro ex_cmds.h proto.h globals.h farsi.h \
diff -caPr ..\vimorg/src/proto/if_python3.pro ./src/proto/if_python3.pro
*** ..\vimorg/src/proto/if_python3.pro	1970-01-01 01:00:00.000000000 +0100
--- ./src/proto/if_python3.pro	2010-04-19 17:39:53.501188200 +0200
***************
*** 0 ****
--- 1,8 ----
+ /* if_python.c */
+ int python3_enabled __ARGS((int verbose));
+ void python3_end __ARGS((void));
+ void ex_python3 __ARGS((exarg_T *eap));
+ void ex_py3file __ARGS((exarg_T *eap));
+ void python3_buffer_free __ARGS((buf_T *buf));
+ void python3_window_free __ARGS((win_T *win));
+ /* vim: set ft=c : */
diff -caPr ..\vimorg/src/proto.h ./src/proto.h
*** ..\vimorg/src/proto.h	2010-04-19 14:14:44.799367500 +0200
--- ./src/proto.h	2010-04-19 17:39:53.501188200 +0200
***************
*** 167,172 ****
--- 167,176 ----
  #  include "if_python.pro"
  # endif
  
+ # ifdef FEAT_PYTHON3
+ #  include "if_python3.pro"
+ # endif
+ 
  # ifdef FEAT_TCL
  #  include "if_tcl.pro"
  # endif
diff -caPr ..\vimorg/src/structs.h ./src/structs.h
*** ..\vimorg/src/structs.h	2010-04-19 14:14:44.518250700 +0200
--- ./src/structs.h	2010-04-19 17:39:53.516808200 +0200
***************
*** 1518,1523 ****
--- 1518,1527 ----
      void	*b_python_ref;	/* The Python reference to this buffer */
  #endif
  
+ #ifdef FEAT_PYTHON3
+     void	*b_python3_ref;	/* The Python3 reference to this buffer */
+ #endif
+ 
  #ifdef FEAT_TCL
      void	*b_tcl_ref;
  #endif
***************
*** 2055,2060 ****
--- 2059,2068 ----
      void	*w_python_ref;		/* The Python value for this window */
  #endif
  
+ #ifdef FEAT_PYTHON3
+     void	*w_python3_ref;		/* The Python value for this window */
+ #endif
+ 
  #ifdef FEAT_TCL
      void	*w_tcl_ref;
  #endif
diff -caPr ..\vimorg/src/version.c ./src/version.c
*** ..\vimorg/src/version.c	2010-04-19 14:14:45.299130700 +0200
--- ./src/version.c	2010-04-19 17:39:53.516808200 +0200
***************
*** 450,455 ****
--- 450,464 ----
  #else
  	"-python",
  #endif
+ #ifdef FEAT_PYTHON3
+ # ifdef DYNAMIC_PYTHON3
+ 	"+python3/dyn",
+ # else
+ 	"+python3",
+ # endif
+ #else
+ 	"-python3",
+ #endif
  #ifdef FEAT_QUICKFIX
  	"+quickfix",
  #else
diff -caPr ..\vimorg/src/vim.h ./src/vim.h
*** ..\vimorg/src/vim.h	2010-04-19 14:14:44.471397900 +0200
--- ./src/vim.h	2010-04-19 17:39:53.516808200 +0200
***************
*** 13,18 ****
--- 13,19 ----
  #if defined(__BORLANDC__) && defined(WIN32) && !defined(DEBUG)
  #if defined(FEAT_PERL) || \
      defined(FEAT_PYTHON) || \
+     defined(FEAT_PYTHON3) || \
      defined(FEAT_RUBY) || \
      defined(FEAT_TCL) || \
      defined(FEAT_MZSCHEME) || \
diff -caPr ..\vimorg/src/window.c ./src/window.c
*** ..\vimorg/src/window.c	2010-04-19 14:14:45.705188300 +0200
--- ./src/window.c	2010-04-19 17:39:53.532428200 +0200
***************
*** 4354,4359 ****
--- 4354,4363 ----
      python_window_free(wp);
  #endif
  
+ #ifdef FEAT_PYTHON3
+     python3_window_free(wp);
+ #endif
+ 
  #ifdef FEAT_TCL
      tcl_window_free(wp);
  #endif
